

%[if %("%id=sentry_config%" == "password")% ]%
<?php
  // This code is loaded if the stack is configured to protect a webpage. It checks for our password cookie and redirects to the login page if none is found.

  // Your passwords
  $passwords = "%id=protect_passwords%";

  // Cookie name
  $cookiename = "%id=protection_cookie_name%";

  // Redirect to login page
  $redirect_away = "%id=login_page_link -href%%id=protection_query_string%";

  // Convert the string to an array
  $array = explode(" ", $passwords);

  // Firstly, do we have a sentry_cookie set?
  if(isset($_COOKIE[$cookiename])){
    // Cookie found
  } else {
    // No cookie, send user to the login page
    echo '<meta http-equiv="refresh" content="0;url=' . $redirect_away . '">"';
    echo '<script>window.location.href = ' . $redirect_away . ';</script>';
    exit;
  }

  // Secondly, does the cookie value match one of our passwords?
  foreach ($array as $eachpassword) {
    $matchingpassword = false;

    if ($_COOKIE[$cookiename] === $eachpassword) {
      $matchingpassword = true;
      break;
    }
  }

  // Finally, reject a user from the page if no matching cookie value is found and exit.
  if ($matchingpassword === false) {
    echo '<meta http-equiv="refresh" content="0;url=' . $redirect_away . '">"';
    echo '<script>window.location.href = ' . $redirect_away . ';</script>';
    exit;
  }

?>
%[endif]%


%[if %("%id=sentry_config%" == "login")% ]%
<?php
  // This code is loaded if the stack is configured to display the login form. It creates our tracking cookie and matching password, when the user logs in.

  /* Your password */
  $passwords = "%id=login_passwords%";

  // Cookie name
  $cookiename = "%id=login_cookie_name%";

  /* Redirects here after login */
  $redirect_after_login = '%id=login_redirect -href%%id=login_query_string%';

  if (isset($_POST['sentry_password_%id%']) && (!empty($_POST['sentry_password_%id%']))) {

    $userpwd = $_POST['sentry_password_%id%'];

    // Use regex instead of strpos, so we get the whole word boundary delimiter, instead of letters or part words.
    if(preg_match("/\b{$userpwd}\b/i", $passwords)) {

      // Set cookies with Javascript, has to be done with JS instead of PHP to prevent 'header already sent' errors.
      echo '<script>var sentry_cookie_expires = new Date(); sentry_cookie_expires.setTime(sentry_cookie_expires.getTime() + (%id=cookie_expiry% * %id=cookie_expiry_units%)); document.cookie = "' . $cookiename . '=' . $userpwd . '; expires="+sentry_cookie_expires+"; path=/; %%[[if publish]]%%%[if %("%id=secure_cookies%" == "true")% ]%secure%[endif]%%%[[endif]]%%";</script>';

      // Redirect the page
      echo '<meta http-equiv="refresh" content="0;url=' . $redirect_after_login . '">"';

      %[if %("%id=incorrect_logins%" == "false")% ]%exit;%[endif]%
    }

    %[if %("%id=incorrect_logins%" == "true")% ]%
    else {
      %[if %("%id=log_failed_logins%" == "true")% ]%
      $log_date = date('d/m/y @ H:i:s');
      $log_incorrect = $_POST['sentry_password_%id%'];
      $log_ipaddress = $_SERVER[REMOTE_ADDR];
      $log_useragent = $_SERVER[HTTP_USER_AGENT];
      file_put_contents('sentry-failed-logins.log', $log_date . " Incorrect Password Entered: " . $log_incorrect . " From IP Address: " . $log_ipaddress . " User Agent: " . $log_useragent . PHP_EOL, FILE_APPEND);
      %[endif]%

      // Nullify the tracking cookie. Delete any that already exisits.
      echo '<script>document.cookie = "' . $cookiename . '=; expires=Thu, 01 Jan 1970 00:00:00 UTC; path=/; %%[[if publish]]%%%[if %("%id=secure_cookies%" == "true")% ]%secure%[endif]%%%[[endif]]%%;";</script>';

      //  Redirect to incorrect login attempts.
      echo '<script>window.location.href = "%id=incorrect_login_link -href%%id=incorrect_login_query_string%";</script>';
      exit;
    }
    %[endif]%

  }
?>
%[endif]%
